
/*
 * Demo programmes for libgnet
 * Copyright (C) 1997 Indrek Mandre (indrek@warp.edu.ee)
 * This programme is free software which belongs under the GNU GPL.
 */

#include <stdio.h>
#include <stdlib.h>

#include "gnet.h"

struct MY_STRUCT {			/* Our structure for describing clients */
	GN_client	*client;
	int		status;
	char		name[256];
};

#define WAIT_NAME	1

static struct MY_STRUCT *clients[256];	/* We have maximum 256 clients */

void remove_client ( int i )	/* Function for removing client %d */
{
  printf ("Removing client from %s\n", clients[i]->client->fromadd );
  GN_rem_client ( clients[i]->client );
  free ( clients[i] );
  clients[i] = NULL;
}

int main ()
{
 GN_server *serv;
 int i, j;
 int NC;
 char port[256];

 printf ("Enter port number on which we crawl: ");
  gets ( port );

 for ( i=0; i<256; i++ ) clients[i] = NULL;	/* No clients at the moment */

 if ( ( serv = GN_init_server ( NET_UNIX, atoi ( port ), 0 ) ) == NULL ) {
 	fprintf ( stderr, GN_error );
	exit (-1);				/* Created server */
 }

 for (;;) {

    GN_check_server ( serv );			/* Check all the sockets */

    if ( GN_is_new_client ( serv ) ) {		/* Do we have new client?? */

    	NC = 0;					/* Find empty client space */
    	while ( clients[NC] != NULL ) NC ++;

 	clients[NC] = malloc ( sizeof ( struct MY_STRUCT ) );

 	clients[NC]->client = GN_accept_client ( serv );  /* Accept client */

 	clients[NC]->status = WAIT_NAME;	/* STATUS: wait for client name */

 	printf ("New client from %s!\n", clients[NC]->client->fromadd);
    }

    for ( i=0; i<256; i++ )
      if ( clients[i] != NULL ) {		/* Check all clients */
    	if ( GN_is_client_data ( clients[i]->client ) && clients[i]->status == 0 ) {
    		char data[16384];
    		int len;

    		len = GN_serv_recv_data ( clients[i]->client, data, 16384 );

    		if ( len <= 0 )	/* When error, remove the client */
    			remove_client (i);
    		   else 	/* Otherwise send data to all other clients */
    		for ( j = 0; j<256; j++ )

    		   if ( clients[j] != NULL ) {
    		   	char data2[16384];

    		   	sprintf ( data2, "%s: %s", clients[i]->name, data );

    			if ( GN_serv_send_data ( clients[j]->client, data2, strlen ( data2 ) + 1 ) <= 0 ) remove_client (i);

		   }
    	} else if ( GN_is_client_data ( clients[i]->client ) ) {
    		int len;		/* As first string read in client name */

    		len = GN_serv_recv_data ( clients[i]->client, clients[i]->name, 256 );

    		clients[i]->status = 0;	/* Set status to usual 0 */

    		if ( len <= 0 ) remove_client ( i );
    	}
      }

    usleep (10000);	/* Let the computer rest in peace for a while */
 }

 return 0;
}

